"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bold = exports.reset = exports.hasColor = exports.colorParam = exports.setHasColor = exports.disableColor = void 0;
const supports_color_1 = require("supports-color");
var colorEnabled = undefined;
const disableColor = () => {
    colorEnabled = false;
};
exports.disableColor = disableColor;
// Enable or disable color. Passing undefined will enable colors if they are
// supported in the current environment.
const setHasColor = (color) => {
    if (colorEnabled === undefined) {
        if (color === undefined) {
            // NB: `supports-color` is going to parse command line arguments on its own.
            colorEnabled = supports_color_1.stdout !== false && supports_color_1.stdout.hasBasic;
        }
        else {
            colorEnabled = color;
        }
    }
};
exports.setHasColor = setHasColor;
// The value for the `color` parameter to the `/schema/1` endpoints.
const colorParam = () => {
    return (0, exports.hasColor)() ? "ansi" : "";
};
exports.colorParam = colorParam;
const hasColor = () => {
    return colorEnabled !== null && colorEnabled !== void 0 ? colorEnabled : false;
};
exports.hasColor = hasColor;
const reset = () => esc(`\u001b[0m`);
exports.reset = reset;
const bold = () => esc(`\u001b[1m`);
exports.bold = bold;
const esc = (str) => {
    if ((0, exports.hasColor)()) {
        return str;
    }
    else {
        return "";
    }
};
